/*
 * Vairous ways of fiddling with binary files.
 */

/* Gah, no stdint.h with MSVC. */
#if defined(_MSC_VER)
  typedef __int8 int8_t;
  typedef unsigned __int8 uint8_t;
  typedef __int16 int16_t;
  typedef unsigned __int16 uint16_t;
  typedef __int32 int32_t;
  typedef unsigned __int32 uint32_t;
  typedef __int64 int64_t;
  typedef unsigned __int64 uint64_t;
#else
#include <stdint.h>
#endif


uint16_t read_16_be(uint8_t *buf);

uint32_t read_32(uint8_t *buf);

uint32_t read_32_be(uint8_t *buf);

int check_header(uint8_t *buf, char *header);
